﻿Option Strict On
Option Explicit On

Imports System.Runtime.InteropServices
Public Class AC_MemStruct
    'Size of new memory structures:
    'Local\acpmf = 308
    'physics : Local\acpmf_physics = 248
    'graphics : Local\acpmf_graphics = 248
    'static : Local\acpmf_static = 248 

    Public Enum AC_SESSION_TYPE
        AC_UNKNOWN = -1
        AC_PRACTICE = 0
        AC_QUALIFY = 1
        AC_RACE = 2
        AC_HOTLAP = 3
        AC_TIME_ATTACK = 4
        AC_DRIFT = 5
        AC_DRAG = 6
    End Enum

    Public Enum AC_STATUS
        AC_OFF = 0
        AC_REPLAY = 1
        AC_LIVE = 2
        AC_PAUSE = 3
    End Enum

    Public Enum AC_FLAG_TYPE
        AC_NO_FLAG = 0
        AC_BLUE_FLAG = 1
        AC_YELLOW_FLAG = 2
        AC_BLACK_FLAG = 3
        AC_WHITE_FLAG = 4
        AC_CHECKERED_FLAG = 5
        AC_PENALTY_FLAG = 6
    End Enum

    Public Structure MVec
        Public X As Single
        Public Y As Single 'vertikale Achse
        Public Z As Single
    End Structure

    Public Structure Tyres
        Public Front_Left As Single
        Public Front_Right As Single
        Public Rear_Left As Single
        Public Rear_Right As Single
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=4, CharSet:=CharSet.Unicode)>
    Public Structure SPageFilePhysics
        Public packetId As Int32
        Public gas As Single
        Public brake As Single
        Public fuel As Single
        Public gear As Int32
        Public rpms As Int32
        Public steerAngle As Single
        Public speedKmh As Single
        Public velocity As MVec 'world coordinates; y = vertikale Achse
        Public accG As MVec 'local coordinates
        Public wheelSlip As Tyres
        Public wheelLoad As Tyres
        Public wheelsPressure As Tyres
        Public wheelAngularSpeed As Tyres
        Public tyreWear As Tyres
        Public tyreDirtyLevel As Tyres
        Public tyreCoreTemperature As Tyres
        Public camberRAD As Tyres
        Public suspensionTravel As Tyres
        Public drs As Single
        Public tc As Single
        Public heading As Single
        Public pitch As Single
        Public roll As Single
        Public cgHeight As Single
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=5)>
        Public carDamage() As Single
        Public numberOfTyresOut As Int32
        Public pitLimiterOn As Int32
        Public abs As Single

        Public kersCharge As Single
        Public kersInput As Single
        Public autoShifterOn As Int32
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=2)>
        Public rideHeight() As Single
        Public turboBoost As Single
        Public ballast As Single
        Public airDensity As Single
        Public airTemp As Single
        Public roadTemp As Single
        '<MarshalAs(UnmanagedType.ByValArray, SizeConst:=3)>
        Public localAngularVel As MVec
        Public finalFF As Single
        Public performanceMeter As Single

        Public engineBrake As Int32
        Public ersRecoveryLevel As Int32
        Public ersPowerLevel As Int32
        Public ersHeatCharging As Int32
        Public ersIsCharging As Int32
        Public kersCurrentKJ As Single

        Public drsAvailable As Int32
        Public drsEnabled As Int32

        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)>
        Public brakeTemp() As Single
        Public clutch As Single
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)>
        Public tyreTempI() As Single
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)>
        Public tyreTempM() As Single
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)>
        Public tyreTempO() As Single

        Public isAIControlled As Int32
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=12)>
        Public tyreContactPoint() As Single
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=12)>
        Public tyreContactNormal() As Single
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=12)>
        Public tyreContactHeading() As Single

        Public brakeBias As Single
        Public LocalVelocity As MVec 'local coordinates
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=4, CharSet:=CharSet.Unicode)>
    Public Structure SPageFileGraphic
        Public packetId As Int32
        Public status As AC_STATUS
        Public session As AC_SESSION_TYPE
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=15)>
        Public currentTime As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=15)>
        Public lastTime As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=15)>
        Public bestTime As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=15)>
        Public split As String
        Public completedLaps As Int32
        Public position As Int32
        Public iCurrentTime As Int32
        Public iLastTime As Int32
        Public iBestTime As Int32
        Public sessionTimeLeft As Single
        Public distanceTraveled As Single
        Public isInPit As Int32
        Public currentSectorIndex As Int32
        Public lastSectorTime As Int32
        Public numberOfLaps As Int32
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=33)>
        Public tyreCompound As String

        Public replayTimeMultiplier As Single
        Public normalizedCarPosition As Single

        Public carCoordinates As MVec

        Public PenaltyTime As Single
        Public Flag As AC_FLAG_TYPE
        Public IdealLineOn As Int32

        '// since 1.5
        Public IsInPitLane As Int32
        Public SurfaceGrip As Single

        '// since 1.13
        Public MandatoryPitDone As Int32
    End Structure

    <StructLayout(LayoutKind.Sequential, Pack:=4, CharSet:=CharSet.Unicode)>
    Public Structure SPageFileStatic
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=15)>
        Public smVersion As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=15)>
        Public acVersion As String

        'session static info
        Public numberOfSessions As Int32
        Public numCars As Int32
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=33)>
        Public carModel As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=33)>
        Public track As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=33)>
        Public playerName As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=33)>
        Public playerSurname As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=33)>
        Public playerNick As String
        Public sectorCount As Int32

        'car static info
        Public maxTorque As Single
        Public maxPower As Single
        Public maxRpm As Int32
        Public maxFuel As Single
        Public suspensionMaxTravel As Tyres
        Public tyreRadius As Tyres

        'since 1.5
        Public MaxTurboBoost As Single
        Public Deprecated1 As Single ' // AirTemp since 1.6 In physic
        Public Deprecated2 As Single ' // RoadTemp since 1.6 In physic
        Public PenaltiesEnabled As Int32
        Public AidFuelRate As Single
        Public AidTireRate As Single
        Public AidMechanicalDamage As Single
        Public AidAllowTyreBlankets As Int32
        Public AidStability As Single
        Public AidAutoClutch As Int32
        Public AidAutoBlip As Int32

        'since 1.7.1
        Public HasDRS As Int32
        Public HasERS As Int32
        Public HasKERS As Int32
        Public KersMaxJoules As Single
        Public EngineBrakeSettingsCount As Int32
        Public ErsPowerControllerCount As Int32

        'since 1.7.2
        Public TrackSPlineLength As Single
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=15)>
        Public TrackConfiguration As String

        'since 1.10.2
        Public ErsMaxJ As Single

        'since 1.13
        Public IsTimedRace As Int32
        Public HasExtraLap As Int32
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=33)>
        Public CarSkin As String
        Public ReversedGridPositions As Int32
        Public PitWindowStart As Int32
        Public PitWindowEnd As Int32
    End Structure

    '<StructLayout(LayoutKind.Sequential, Pack:=4, CharSet:=CharSet.Unicode)>
    'Public Structure AC_MMF
    '    Public packetId As Int32
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=32)> _
    '    Public carModel As String
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=32)> _
    '    Public track As String
    '    Public maxTorque As Single
    '    Public maxPower As Single
    '    Public gear As Int32
    '    Public rpms As Int32
    '    Public maxRpm As Int32
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=10)> _
    '    Public currentTime As String
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=10)> _
    '    Public lastTime As String
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=10)> _
    '    Public bestTime As String
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=10)> _
    '    Public split As String
    '    Public gas As Single
    '    Public brake As Single
    '    Public fuel As Single
    '    Public maxFuel As Single
    '    Public speed As Single
    '    Public completedLaps As Int32
    '    Public position As Int32
    '    Public numCars As Int32
    '    Public numberOfLaps As Int32
    '    Public iCurrentTime As Int32
    '    Public iLastTime As Int32
    '    Public iBestTime As Int32
    '    Public accG As MVec 'local coordinates
    '    Public suspensionTravel As Tyres
    '    Public wheelSlip As Tyres
    '    Public wheelLoad As Tyres
    '    Public suspensionMaxTravel As Tyres
    '    Public distanceTraveled As Single
    '    Public isInPit As Byte
    '    Public currentSector As Int32
    '    Public currentSectorTime As Int32
    '    Public sectorCount As Int32
    '    Public wheelsPressure As Tyres
    '    Public drs As Byte
    '    Public tc As Single
    '    Public heading As Single
    '    Public pitch As Single
    '    Public roll As Single
    'End Structure

    '<StructLayout(LayoutKind.Sequential, Pack:=4)> _
    'Public Structure SPageFileStatic
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=10)> _
    '    Public smVersion() As String
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=10)> _
    '    Public acVersion() As String
    '    ' session static info
    '    Public numberOfSessions As Int32
    '    Public numCars As Int32
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=10)> _
    '    Public carModel() As String
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=10)> _
    '    Public track() As String
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=10)> _
    '    Public playerName() As String
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=10)> _
    '    Public playerSurname() As String
    '    <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=10)> _
    '    Public playerNick() As String
    '    Public sectorCount As Int32
    '    '// car static info
    '    Public maxTorque As Single
    '    Public maxPower As Single
    '    Public maxRpm As Int32
    '    Public maxFuel As Single
    '    Public suspensionMaxTravel As Tyres
    '    Public tyreRadius As Tyres
    'End Structure
End Class
